<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Blank Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <!-- Copy thêm vào -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">


</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Alexander Pierce</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="index.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="index2.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="index3.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-header">EXAMPLES</li>
            <li class="nav-item">
              <a href="voucher.html" class="nav-link">
                <i class="nav-icon far fa-calendar-alt"></i>
                <p>
                  Voucher
                  <span class="badge badge-info right">2</span>
                </p>
              </a>
            </li>
            <li class="nav-item">
              <a href="user_list.html" class="nav-link">
                <i class="nav-icon far fa-image"></i>
                <p>
                  User List
                </p>
              </a>
            </li>
            <li class="nav-item">
              <a href="Filter orders.html" class="nav-link">
                <i class="nav-icon far fa-image"></i>
                <p>
                  Filter Orders
                </p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-envelope"></i>
                <p>
                  Mailbox
                  <i class="fas fa-angle-left right"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="../mailbox/mailbox.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Inbox</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="../mailbox/compose.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Compose</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="../mailbox/read-mail.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Read</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-book"></i>
                <p>
                  Pages
                  <i class="fas fa-angle-left right"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="../examples/invoice.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Invoice</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="../examples/contact-us.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Contact us</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-header">MISCELLANEOUS</li>
            <li class="nav-item">
              <a href="iframe.html" class="nav-link">
                <i class="nav-icon fas fa-ellipsis-h"></i>
                <p>Tabbed IFrame Plugin</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="https://adminlte.io/docs/3.1/" class="nav-link">
                <i class="nav-icon fas fa-file"></i>
                <p>Documentation</p>
              </a>
            </li>
            <li class="nav-header">MULTI LEVEL EXAMPLE</li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="fas fa-circle nav-icon"></i>
                <p>Level 1</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-circle"></i>
                <p>
                  Level 1
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Level 2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>
                      Level 2
                      <i class="right fas fa-angle-left"></i>
                    </p>
                  </a>
                  <ul class="nav nav-treeview">
                    <li class="nav-item">
                      <a href="#" class="nav-link">
                        <i class="far fa-dot-circle nav-icon"></i>
                        <p>Level 3</p>
                      </a>
                    </li>
                    <li class="nav-item">
                      <a href="#" class="nav-link">
                        <i class="far fa-dot-circle nav-icon"></i>
                        <p>Level 3</p>
                      </a>
                    </li>
                    <li class="nav-item">
                      <a href="#" class="nav-link">
                        <i class="far fa-dot-circle nav-icon"></i>
                        <p>Level 3</p>
                      </a>
                    </li>
                  </ul>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Level 2</p>
                  </a>
                </li>
              </ul>
            </li>
            <li class="nav-header">LABELS</li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-circle text-danger"></i>
                <p class="text">Important</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-circle text-warning"></i>
                <p>Warning</p>
              </a>
            </li>
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon far fa-circle text-info"></i>
                <p>Informational</p>
              </a>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1>User List</h1>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">User List</li>
              </ol>
            </div>
          </div>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <!-- Vùng header -->
        <div class="container-fluid">
          <div class="text-center">
              <h2>Registration List</h2>
          </div>
          <hr>
          <div class="form-group">
              <button class="btn btn-success" id="btn-add-user"> <i class="fa fa-plus"></i>&nbsp; New User </button>
          </div>
  
          <table class="table table-bordered table-striped table-hover" id="tbl-users">
              <thead style="background-color: rgb(38, 38, 39); text-align: center; color: white">
                  <tr>
                      <th scope="col">No.</th>
                      <th scope="col">Firstname</th>
                      <th scope="col">Lastname</th>
                      <th scope="col">Country</th>
                      <th scope="col">Subject</th>
                      <th scope="col">Customer Type</th>
                      <th scope="col">Register-Status</th>
                      <th scope="col">Action</th>
                  </tr>
              </thead>
              <tbody></tbody>
          </table>
      </div>
  
      <!-- Vùng Modal -->
  
      <!-- Create user modal -->
      <div>
          <div id="create-user-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                  <div class="modal-content">
                      <div class="modal-header">
                          <h5 class="modal-title" id="h5-modal-title">Create new user</h5>
                          <button class="close" data-dismiss="modal">&times;</button>
                      </div>
                      <div class="modal-body">
                          <form>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="input-create-firstname">Firstname</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <input type="text" id="input-create-firstname" placeholder="Firstname"
                                          class="form-control">
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="input-create-lastname">Lastname</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <input type="text" id="input-create-lastname" placeholder="Lastname"
                                          class="form-control">
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="select-create-country">Country</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <select id="select-create-country" class="form-control">
                                          <option value="VN"> VietNam </option>
                                          <option value="AUS"> Australia </option>
                                          <option value="USA"> USA </option>
                                          <option value="CAN"> Canada </option>
                                      </select>
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="select-create-customer-type">Customer Type</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <select id="select-create-customer-type" class="form-control">
                                          <option value="Standard"> Standard </option>
                                          <option value="Gold"> Gold </option>
                                          <option value="Premium"> Premium </option>
                                      </select>
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="">Subject</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <textarea id="textarea-subject" class="form-control"
                                          placeholder="Enter Subject"></textarea>
                                  </div>
                              </div>
  
                          </form>
                      </div>
                      <div class="modal-footer">
                          <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                          <button class="btn btn-primary" id="btn-create-user">Create User</button>
                      </div>
                  </div>
              </div>
          </div>
      </div>
  
      <!-- Update user modal -->
      <div>
          <div id="update-user-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                  <div class="modal-content">
                      <div class="modal-header">
                          <h5 class="modal-title" id="h5-modal-title">Update user</h5>
                          <button class="close" data-dismiss="modal">&times;</button>
                      </div>
                      <div class="modal-body">
                          <form>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="input-update-firstname">Firstname</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <input type="text" id="input-update-firstname" placeholder="Firstname"
                                          class="form-control">
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="input-update-lastname">Lastname</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <input type="text" id="input-update-lastname" placeholder="Lastname"
                                          class="form-control">
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="select-update-country">Country</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <select id="select-update-country" class="form-control">
                                          <option value="VN"> VietNam </option>
                                          <option value="AUS"> Australia </option>
                                          <option value="USA"> USA </option>
                                          <option value="CAN"> Canada </option>
                                      </select>
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="select-update-customer-type">Customer Type</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <select id="select-update-customer-type" class="form-control">
                                          <option value="Standard"> Standard </option>
                                          <option value="Gold"> Gold </option>
                                          <option value="Premium"> Premium </option>
                                      </select>
                                  </div>
                              </div>
                              <div class="row form-group">
                                  <div class="col-sm-4">
                                      <label for="">Subject</label>
                                  </div>
                                  <div class="col-sm-8">
                                      <textarea id="update-textarea-subject" class="form-control"
                                          placeholder="Enter Subject"></textarea>
                                  </div>
                              </div>
  
                          </form>
                      </div>
                      <div class="modal-footer">
                          <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                          <button class="btn btn-primary" id="btn-update-user">Update</button>
                      </div>
                  </div>
              </div>
          </div>
      </div>
  
      <!-- Delete confirm modal -->
      <div>
          <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
              <div class="modal-dialog">
                  <div class="modal-content">
                      <div class="modal-header">
                          <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                          <button class="close" data-dismiss="modal">&times;</button>
                      </div>
                      <div class="modal-body">
                          <label>Do you want to delete this user?</label>
                      </div>
                      <div class="modal-footer">
                          <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                          <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                      </div>
                  </div>
              </div>
          </div>
      </div>

      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- Copy thêm vào -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>

</body>
<script>
  "use strict";


  // gán sự kiện cho các nút Detail


  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
  //biến toàn cục để lưu trữ id user đang được update or delete. mặc định là 0
  var gUserId = 0;
  const gDATA_COLUMN = [
      //gán với tên các cột của array
      "id",
      "firstname",
      "lastname",
      "country",
      "subject",
      "customerType",
      "registerStatus",
      "action",
  ];
  const gUSER_ID_COL = 0;
  const gFIRST_NAME_COL = 1;
  const gLAST_NAME_COL = 2;
  const gCOUNTRY_COL = 3;
  const gSUBJECT_COL = 4;
  const gCUSTOMER_TYPE_COL = 5;
  const gREGISTER_STATUS_COL = 6;
  const gACTION_COL = 7;

  //khai báo datatable & mapping columns
  var gUserTable = $("#tbl-users").DataTable({
      //gán column data
      columns: [
          { data: gDATA_COLUMN[gUSER_ID_COL] },
          { data: gDATA_COLUMN[gFIRST_NAME_COL] },
          { data: gDATA_COLUMN[gLAST_NAME_COL] },
          { data: gDATA_COLUMN[gCOUNTRY_COL] },
          { data: gDATA_COLUMN[gSUBJECT_COL] },
          { data: gDATA_COLUMN[gCUSTOMER_TYPE_COL] },
          { data: gDATA_COLUMN[gREGISTER_STATUS_COL] },
          { data: gDATA_COLUMN[gACTION_COL] }
      ],
      columnDefs: [
          //định nghĩa các cột hiện ra
          {
              targets: gACTION_COL,
              className: "text-center",
              defaultContent: `
                      <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                      <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                  `
          }
      ]

  });

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
      onPageLoading();

      //1 - C: gán sự kiện create
      $("#btn-add-user").on("click", function () {
          onBtnAddUserClick();
      });


      //3- U: gán sự kiện update
      $("#tbl-users").on("click", ".edit-user", function () {
          onBtnEditClick(this);
      });

      //4- D: gán sự kiện delete
      $("#tbl-users").on("click", ".delete-user", function () {
          onBtnDeleteClick(this);
      });

      //gán sự kiện cho nút create user trên modal
      $("#btn-create-user").on("click", function () {
          onBtnCreateUserClick();
      });

      //gán sự kiện cho nút update user trên modal
      $("#btn-update-user").on("click", function () {
          onBtnUpdateUserClick();
      });

      // gán sự kiện cho nút Confirm trên modal delete
      $("#btn-confirm-delete-user").on("click", function () {
          onBtnConfirmDeleteClick();
      });

  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

  //hàm onpageload
  function onPageLoading() {
      //1- R: Read / Load user
      callAPIGetDataUser();
  }

  //hàm gọi button sửa
  function onBtnEditClick(paramBtnEdit) {
      "use strict";
      //lưu thông tin userId đang được edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramBtnEdit);
      console.log("Id của user tương ứng = " + gUserId);
      // load dữ liệu vào các trường dữ liệu trong modal
      getUserById(gUserId);
  }

  //hàm xử lý sự kiện khi icon delete user trên bảng được click
  function onBtnDeleteClick(paramBtnDelete) {
      //lưu thông tin userId đang được edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramBtnDelete);
      console.log("Id của user tương ứng = " + gUserId);
      // bật modal confirm lên
      $("#delete-confirm-modal").modal("show");
  }


  // hàm xử lý sự kiện create voucher modal click
  function onBtnAddUserClick() {
      // hiển thị modal trắng lên
      $("#create-user-modal").modal("show");

  };

  //hàm xử lý sự kiện create user modal click
  function onBtnCreateUserClick() {
      console.log("Button create được click");
      //khai báo đối tượng chứa user data
      var vObjRequestData = {
          firstname: "",
          lastname: "",
          subject: "",
          country: "",
          customerType: ""
      };
      // B1: Thu thập dữ liệu
      getCreateUserData(vObjRequestData);
      // B2: Validate insert
      var vIsUserValidate = validateUserData(vObjRequestData);
      if (vIsUserValidate) {
          // B3: insert user
          $.ajax({
              url: gBASE_URL,
              type: "POST",
              contentType: "application/json;charset=UTF-8",
              data: JSON.stringify(vObjRequestData),
              success: function (paramRes) {
                  // B4: xử lý front-end
                  handleInsertUserSuccess()
              },
              error: function (paramErr) {
                  console.log(paramErr.status);
              }
          });
      }
  }

  // hàm get user by id
  function getUserById(paramUserId) {
      $.ajax({
          url: gBASE_URL + paramUserId,
          type: "GET",
          success: function (paramRes) {
              debugger;
              showVoucherDataToModal(paramRes);
          },
          error: function (paramErr) {
              console.log(paramErr.status);
          }
      });
      // hiển thị modal lên
      $("#update-user-modal").modal("show");
  }

  // hàm show voucher obj lên modal
  function showVoucherDataToModal(paramUserObj) {
      $("#input-update-firstname").val(paramUserObj.firstname);
      $("#input-update-lastname").val(paramUserObj.lastname);
      $("#select-update-country").val(paramUserObj.country);
      $("#update-textarea-subject").val(paramUserObj.subject);
      $("#select-update-customer-type").val(paramUserObj.customerType)
  }

  // hàm xử lý sự kiện update user modal click
  function onBtnUpdateUserClick() {

      // khai báo đối tượng chứa user data
      var vObjRequestData = {
          firstname: "",
          lastname: "",
          subject: "",
          country: "",
          customerType: ""
      };
      // B1: Thu thập dữ liệu
      getUpdateUserData(vObjRequestData);
      // B2: Validate update
      var vIsUserValidate = validateUserData(vObjRequestData);
      if (vIsUserValidate) {
          // B3: update voucher
          $.ajax({
              url: gBASE_URL + gUserId,
              type: "PUT",
              contentType: "application/json;charset=UTF-8",
              data: JSON.stringify(vObjRequestData),
              success: function (paramRes) {
                  // B4: xử lý front-end
                  handleUpdateUserSuccess();
              },
              error: function (paramErr) {
                  console.log(paramErr.status);
              }
          });
      }
  }

  // hàm xử lý sự kiện confirm delete
  function onBtnConfirmDeleteClick() {
      // b1: thu thập dữ liệu (ko có)
      // B2: validate dữ liệu (ko có)
      // b3: gọi api để xóa
      $.ajax({
          url: gBASE_URL + gUserId,
          type: "DELETE",
          success: function (paramRes) {
              handleDeleteVoucherSuccess();
          },
          error: function (paramErr) {
              alert("Can not delete this user");
              $("#delete-confirm-modal").modal("hide");
          }
      });
      // b4: xử lý hiển thị front-end
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  //hàm load user data click dùng Ajax
  function callAPIGetDataUser() {
      "use strict";
      $.ajax({
          url: gBASE_URL,
          type: "GET",
          dataType: "json", // added data type
          success: function (res) {
              loadUserDataToTable(res);
          },
          error: function (ajaxContext) {
              alert(ajaxContext.responseText)
          }
      });
  }


  //hàm load data lên table
  function loadUserDataToTable(paramObjUser) {
      "use strict";
      gUserTable.clear();
      gUserTable.rows.add(paramObjUser);
      gUserTable.draw();
  }


  //hàm dựa vào button edit or delete xác định được id user
  function getUserIdFromButton(paramBtn) {
      var vTableRow = $(paramBtn).parents("tr");
      var vUserRowData = gUserTable.row(vTableRow).data();
      return vUserRowData.id;
  }


  //hàm thu thập dữ liệu để create user
  function getCreateUserData(paramUserObj) {
      paramUserObj.firstname = $("#input-create-firstname").val().trim();
      paramUserObj.lastname = $("#input-create-lastname").val().trim();
      paramUserObj.country = $("#select-create-country").val();
      paramUserObj.subject = $("#textarea-subject").val().trim();
      paramUserObj.customerType = $("#select-create-customer-type").val();


  }



  //hàm thu thập dữ liệu để create user
  function getUpdateUserData(paramUserObj) {
      paramUserObj.firstname = $("#input-update-firstname").val().trim();
      paramUserObj.lastname = $("#input-update-lastname").val().trim();
      paramUserObj.country = $("#select-update-country").val();
      paramUserObj.subject = $("#update-textarea-subject").val().trim();
      paramUserObj.customerType = $("#select-update-customer-type").val();
  }



  //hàm validate
  function validateUserData(paramUserObj) {
      if (paramUserObj.firstname === "") {
          alert("Please input firstname");
          return false;
      }
      if (paramUserObj.lastname === "") {
          alert("Please input lastname");
          return false;
      }
      if (paramUserObj.subject === "") {
          alert("Please input subject");
          return false;
      }

      return true;
  }

  //hàm xử lý khi thêm user thành công
  function handleInsertUserSuccess() {
      alert("Added user successfully!");
      callAPIGetDataUser();
      resertCreateUserForm();
      $("#create-user-modal").modal("hide");
  }

  //hàm xử lý khi update thành công
  function handleUpdateUserSuccess() {
      alert("Updated user successfully!");
      callAPIGetDataUser();
      resertCreateUserForm();
      $("#update-user-modal").modal("hide");
  }

  // hàm xử lý hiển thị front-end khi xóa voucher thành công
  function handleDeleteVoucherSuccess() {
      alert("Deleted successfully!");
      callAPIGetDataUser();
      resertCreateUserForm();
      $("#delete-confirm-modal").modal("hide");
  }

  //hàm xóa trắng form create user
  function resertCreateUserForm() {
      $("#input-create-firstname").val("");
      $("#input-create-lastname").val("");
      $("#select-create-country").val("");
      $("#textarea-subject").val("");
      $("#select-create-customer-type").val("");
  }
</script>

</html>